gtkmm: Gtk::RecentFilter Class Reference

gtkmm 2.24.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes

- Class List
- Class Index
- Class Hierarchy
- Class Members

Classes | Public Types | Public Member Functions | Related Functions

# Gtk::RecentFilter Class Reference
RecentFiles

RecentFilter can be used to restrict the files being shown in a RecentChooser. More...

Inheritance diagram for Gtk::RecentFilter:
[legend]
Collaboration diagram for Gtk::RecentFilter:
[legend]

List of all members.

## Classes
class | Info
| A RecentFilter::Info class is used to pass information about the tested file to filter(). More...
## Public Types
typedef sigc::slot< bool, const Info& > | SlotCustom
| For instance, bool on_custom(const Gtk::RecentFilter::Info& filter_info);.
## Public Member Functions
virtual | ~RecentFilter ()
GtkRecentFilter* | gobj ()
| Provides access to the underlying C GtkObject.
const GtkRecentFilter* | gobj () const
| Provides access to the underlying C GtkObject.
| RecentFilter ()
void | set_name (const Glib::ustring& name)
| Sets the human-readable name of the filter; this is the string that will be displayed in the recently used resources selector user interface if there is a selectable list of filters.
Glib::ustring | get_name () const
| Gets the human-readable name for the filter.
void | add_mime_type (const Glib::ustring& mime_type)
| Adds a rule that allows resources based on their registered MIME type.
void | add_pattern (const Glib::ustring& pattern)
| Adds a rule that allows resources based on a pattern matching their display name.
void | add_pixbuf_formats ()
| Adds a rule allowing image files in the formats supported by GdkPixbuf.
void | add_application (const Glib::ustring& application)
| Adds a rule that allows resources based on the name of the application that has registered them.
void | add_group (const Glib::ustring& group)
| Adds a rule that allows resources based on the name of the group to which they belong.
void | add_age (int days)
| Adds a rule that allows resources based on their age - that is, the number of days elapsed since they were last modified.
void | add_custom (RecentFilterFlags needed, const SlotCustom& slot)
RecentFilterFlags | get_needed () const
| Gets the fields that need to be filled in for the structure passed to filter()
## Related Functions
(Note that these are not member functions.)
Gtk::RecentFilter* | wrap (GtkRecentFilter* object, bool take_copy=false)
| A Glib::wrap() method for this object.

## Detailed Description

RecentFilter can be used to restrict the files being shown in a RecentChooser.

Files can be filtered based on their name (with add_pattern()), on their mime type (with add_mime_type()), on the application that has registered them (with add_application()), or by a custom filter function (with add_custom()).

Filtering by mime type handles aliasing and subclassing of mime types; e.g. a filter for text/plain also matches a file with mime type application/rtf, since application/rtf is a subclass of text/plain. Note that RecentFilter allows wildcards for the subtype of a mime type, so you can e.g. filter for image/*.

Normally, filters are used by adding them to a RecentChooser, see RecentChooser::add_filter(), but it is also possible to manually use a filter on a file with filter().

Since gtkmm 2.10:

## Member Typedef Documentation

typedef sigc::slot<bool, const Info&> Gtk::RecentFilter::SlotCustom

For instance, bool on_custom(const Gtk::RecentFilter::Info& filter_info);.

## Constructor & Destructor Documentation

virtual Gtk::RecentFilter::~RecentFilter | ( |  | ) | `[virtual]`

Gtk::RecentFilter::RecentFilter | ( |  | ) |

## Member Function Documentation

void Gtk::RecentFilter::add_age | ( | int | days | ) |

Adds a rule that allows resources based on their age - that is, the number of days elapsed since they were last modified.

Since gtkmm 2.10:

Parameters:

  days | Number of days.

void Gtk::RecentFilter::add_application | ( | const Glib::ustring & | application | ) |

Adds a rule that allows resources based on the name of the application that has registered them.

Since gtkmm 2.10:

Parameters:

  application | An application name.

void Gtk::RecentFilter::add_custom | ( | RecentFilterFlags | needed,
|  | const SlotCustom & | slot
| ) |  |

void Gtk::RecentFilter::add_group | ( | const Glib::ustring & | group | ) |

Adds a rule that allows resources based on the name of the group to which they belong.

Since gtkmm 2.10:

Parameters:

  group | A group name.

void Gtk::RecentFilter::add_mime_type | ( | const Glib::ustring & | mime_type | ) |

Adds a rule that allows resources based on their registered MIME type.

Since gtkmm 2.10:

Parameters:

  mime_type | A MIME type.

void Gtk::RecentFilter::add_pattern | ( | const Glib::ustring & | pattern | ) |

Adds a rule that allows resources based on a pattern matching their display name.

Since gtkmm 2.10:

Parameters:

  pattern | A file pattern.

void Gtk::RecentFilter::add_pixbuf_formats | ( |  | ) |

Adds a rule allowing image files in the formats supported by GdkPixbuf.

Since gtkmm 2.10:

Glib::ustring Gtk::RecentFilter::get_name | ( |  | ) | const

Gets the human-readable name for the filter.

See set_name().

Since gtkmm 2.10:

Returns:
  The name of the filter, or `0`. The returned string is owned by the filter object and should not be freed.

RecentFilterFlags Gtk::RecentFilter::get_needed | ( |  | ) | const

Gets the fields that need to be filled in for the structure passed to filter()

This function will not typically be used by applications; it is intended principally for use in the implementation of Gtk::RecentChooser.

Since gtkmm 2.10:

Returns:
  Bitfield of flags indicating needed fields when calling filter().

const GtkRecentFilter* Gtk::RecentFilter::gobj | ( |  | ) | const`[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Object.

GtkRecentFilter* Gtk::RecentFilter::gobj | ( |  | ) | `[inline]`

Provides access to the underlying C GtkObject.

Reimplemented from Gtk::Object.

void Gtk::RecentFilter::set_name | ( | const Glib::ustring & | name | ) |

Sets the human-readable name of the filter; this is the string that will be displayed in the recently used resources selector user interface if there is a selectable list of filters.

Since gtkmm 2.10:

Parameters:

  name | Then human readable name of filter.

## Friends And Related Function Documentation

Gtk::RecentFilter* wrap | ( | GtkRecentFilter * | object,
|  | bool | take_copy = `false`
| ) |  | `[related]`

A Glib::wrap() method for this object.

Parameters:

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns:
  A C++ instance that wraps this C instance.

The documentation for this class was generated from the following file:

- gtkmm/recentfilter.h